Index: inc/core/class.dc.core.php
===================================================================
--- inc/core/class.dc.core.php	(revision 2706)
+++ inc/core/class.dc.core.php	(revision 2566)
@@ -4,5 +4,5 @@
 # This file is part of Dotclear 2.
 #
-# Copyright (c) 2003-2014 Olivier Meunier & Association Dotclear
+# Copyright (c) 2003-2013 Olivier Meunier & Association Dotclear
 # Licensed under the GPL version 2.0 license.
 # See LICENSE file or
@@ -39,5 +39,4 @@
 	public $rest;		///< <b>dcRestServer</b>	dcRestServer object
 	public $log;		///< <b>dcLog</b>			dcLog object
-	public $stime;		///< <b>float</b>			starting time
 
 	private $versions = null;
@@ -60,10 +59,4 @@
 	public function __construct($driver, $host, $db, $user, $password, $prefix, $persist)
 	{
-		if (defined('DC_START_TIME')) {
-			$this->stime=DC_START_TIME;
-		} else {
-			$this->stime = microtime(true);
-		}
-
 		$this->con = dbLayer::init($driver,$host,$db,$user,$password,$persist);
 
@@ -101,4 +94,7 @@
 
 		$this->log = new dcLog($this);
+
+		$this->addFormater('xhtml', create_function('$s','return $s;'));
+		$this->addFormater('wiki', array($this,'wikiTransform'));
 	}
 
@@ -208,4 +204,5 @@
 	//@}
 
+
 	/// @name Text Formatters methods
 	//@{
@@ -215,22 +212,4 @@
 	argument: the string to transform. It returns the transformed string.
 
-	@param	editor_id	<b>string</b>	Editor id (dcLegacyEditor, dcCKEditor, ...)
-	@param	name		<b>string</b>	Formater name
-	@param	func		<b>callback</b>	Function to use, must be a valid and callable callback
-	*/
-	public function addEditorFormater($editor_id,$name,$func)
-	{
-		if (is_callable($func)) {
-			$this->formaters[$editor_id][$name] = $func;
-		}
-	}
-
-	/// @name Text Formatters methods
-	//@{
-	/**
-	Adds a new text formater which will call the function <var>$func</var> to
-	transform text. The function must be a valid callback and takes one
-	argument: the string to transform. It returns the transformed string.
-
 	@param	name		<b>string</b>		Formater name
 	@param	func		<b>callback</b>	Function to use, must be a valid and callable callback
@@ -238,53 +217,17 @@
 	public function addFormater($name,$func)
 	{
-		$this->addEditorFormater('dcLegacyEditor',$name,$func);
-	}
-
-	/**
-	Returns editors list
-
-	@return	<b>array</b> An array of editors values.
-	*/
-	public function getEditors()
-	{
-		$editors = array();
-
-		foreach (array_keys($this->formaters) as $editor_id) {
-			$editors[$editor_id] = $this->plugins->moduleInfo($editor_id,'name');
-		}
-
-		return $editors;
-	}
-
-	/**
-	Returns formaters list by editor
-
-	@param	editor_id	<b>string</b>	Editor id (dcLegacyEditor, dcCKEditor, ...)
+		if (is_callable($func)) {
+			$this->formaters[$name] = $func;
+		}
+	}
+
+	/**
+	Returns formaters list.
+
 	@return	<b>array</b> An array of formaters names in values.
-
-    /**
-    if @param editor_id is empty:
-    return all formaters sorted by actives editors
-    
-    if @param editor_id is not empty
-    return formaters for an editor if editor is active
-    return empty() array if editor is not active. 
-    It can happens when a user choose an editor and admin deactivate that editor later
-	*/
-	public function getFormaters($editor_id='')
-	{
-		$formaters_list = array();
-
-		if (!empty($editor_id)) {
-            if (isset($this->formaters[$editor_id])) {
-                $formaters_list = array_keys($this->formaters[$editor_id]);
-            }
-		} else {
-			foreach ($this->formaters as $editor => $formaters) {
-				$formaters_list[$editor] = array_keys($formaters);
-			}
-		}
-
-		return $formaters_list;
+	*/
+	public function getFormaters()
+	{
+		return array_keys($this->formaters);
 	}
 
@@ -293,30 +236,15 @@
 	transformed using that formater.
 
-	@param	editor_id	<b>string</b>	Editor id (dcLegacyEditor, dcCKEditor, ...)
 	@param	name		<b>string</b>		Formater name
 	@param	str		<b>string</b>		String to transform
 	@return	<b>string</b>	String transformed
 	*/
-	public function callEditorFormater($editor_id,$name,$str)
-	{
-		if (isset($this->formaters[$editor_id]) && isset($this->formaters[$editor_id][$name])) {
-			return call_user_func($this->formaters[$editor_id][$name],$str);
+	public function callFormater($name,$str)
+	{
+		if (isset($this->formaters[$name])) {
+			return call_user_func($this->formaters[$name],$str);
 		}
 
 		return $str;
-	}
-	//@}
-
-	/**
-	If <var>$name</var> is a valid formater, it returns <var>$str</var>
-	transformed using that formater.
-
-	@param	name		<b>string</b>		Formater name
-	@param	str		<b>string</b>		String to transform
-	@return	<b>string</b>	String transformed
-	*/
-	public function callFormater($name,$str)
-	{
-		return $this->callEditorFormater('dcLegacyEditor',$name,$str);
 	}
 	//@}
@@ -713,5 +641,5 @@
 	   - [url] => Blog URL
 	   - [p]
-		- [permission] => true
+	   	- [permission] => true
 		- ...
 
@@ -865,5 +793,4 @@
 			'edit_size' => 24,
 			'enable_wysiwyg' => true,
-            'editor' => 'dcLegacyEditor',
 			'post_format' => 'wiki'
 		);
@@ -882,5 +809,5 @@
 	   - [super] => (true|false) super admin
 	   - [p]
-		- [permission] => true
+	   	- [permission] => true
 		- ...
 
@@ -1055,17 +982,14 @@
 	private function getBlogCursor($cur)
 	{
-		if (($cur->blog_id !== null
-			&& !preg_match('/^[A-Za-z0-9._-]{2,}$/',$cur->blog_id)) ||
-			(!$cur->blog_id)) {
+		if ($cur->blog_id !== null
+		&& !preg_match('/^[A-Za-z0-9._-]{2,}$/',$cur->blog_id)) {
 			throw new Exception(__('Blog ID must contain at least 2 characters using letters, numbers or symbols.'));
 		}
 
-		if (($cur->blog_name !== null && $cur->blog_name == '') ||
-			(!$cur->blog_name)) {
+		if ($cur->blog_name !== null && $cur->blog_name == '') {
 			throw new Exception(__('No blog name'));
 		}
 
-		if (($cur->blog_url !== null && $cur->blog_url == '') ||
-			(!$cur->blog_url)) {
+		if ($cur->blog_url !== null && $cur->blog_url == '') {
 			throw new Exception(__('No blog URL'));
 		}
@@ -1382,8 +1306,6 @@
 				array('media_img_title_pattern','string','Title ;; Date(%b %Y) ;; separator(, )',
 				'Pattern to set image title when you insert it in a post'),
-				array('nb_post_for_home','integer',20,
-				'Number of entries on first home page'),
 				array('nb_post_per_page','integer',20,
-				'Number of entries on home pages and category pages'),
+				'Number of entries on home page and category pages'),
 				array('nb_post_per_feed','integer',20,
 				'Number of entries on feeds'),
@@ -1400,5 +1322,5 @@
 				array('short_feed_items','boolean',false,
 				'Display short feed items'),
-				array('theme','string','berlin',
+				array('theme','string','default',
 				'Blog theme'),
 				array('themes_path','string','themes',
@@ -1547,21 +1469,4 @@
 		}
 	}
-
-	/**
-	 Return elapsed time since script has been started
-	 @param	  $mtime <b>float</b> timestamp (microtime format) to evaluate delta from
-								  current time is taken if null
-	 @return <b>float</b>		 elapsed time
-	 */
-	public function getElapsedTime ($mtime=null) {
-		if ($mtime !== null) {
-			return $mtime-$this->stime;
-		} else {
-			return microtime(true)-$this->stime;
-		}
-	}
 	//@}
-
-
-
 }
Index: inc/core/class.dc.media.php
===================================================================
--- inc/core/class.dc.media.php	(revision 2659)
+++ inc/core/class.dc.media.php	(revision 2566)
@@ -1002,5 +1002,5 @@
 	}
 
-	public function imageThumbRemove($f)
+	protected function imageThumbRemove($f)
 	{
 		$p = path::info($f);
Index: inc/core/class.dc.modules.php
===================================================================
--- inc/core/class.dc.modules.php	(revision 2708)
+++ inc/core/class.dc.modules.php	(revision 2566)
@@ -131,5 +131,4 @@
 			if ($ns == 'admin') {
 				$this->loadModuleL10Nresources($id,$lang);
-				$this->core->adminurl->register('admin.plugin.'.$id,'plugin.php',array('p'=>$id));
 			}
 			$this->loadNsFile($id,$ns);
Index: inc/core/class.dc.namespace.php
===================================================================
--- inc/core/class.dc.namespace.php	(revision 2567)
+++ inc/core/class.dc.namespace.php	(revision 2566)
@@ -125,34 +125,4 @@
 
 	/**
-	Returns global setting value if exists.
-
-	@param	n		<b>string</b>		setting name
-	@return	<b>mixed</b>
-	*/
-	public function getGlobal($n)
-	{
-		if (isset($this->global_settings[$n]['value'])) {
-			return $this->global_settings[$n]['value'];
-		}
-
-		return null;
-	}
-
-	/**
-	Returns local setting value if exists.
-
-	@param	n		<b>string</b>		setting name
-	@return	<b>mixed</b>
-	*/
-	public function getLocal($n)
-	{
-		if (isset($this->local_settings[$n]['value'])) {
-			return $this->local_settings[$n]['value'];
-		}
-
-		return null;
-	}
-
-	/**
 	Magic __get method.
 	@copydoc ::get
Index: inc/core/class.dc.themes.php
===================================================================
--- inc/core/class.dc.themes.php	(revision 2607)
+++ inc/core/class.dc.themes.php	(revision 2566)
@@ -59,5 +59,5 @@
 		# Themes specifics properties
 		$properties = array_merge(
-			array('parent' => null, 'tplset' => DC_DEFAULT_TPLSET),
+			array('parent' => null),
 			$properties,
 			array('permissions' => 'admin') // force themes perms
Index: inc/core/class.dc.trackback.php
===================================================================
--- inc/core/class.dc.trackback.php	(revision 2674)
+++ inc/core/class.dc.trackback.php	(revision 2566)
@@ -482,7 +482,7 @@
 	}
 
-	private static function detectCharset($content)
-	{
-		return mb_detect_encoding($content,
+	private static function detectCharset($string)
+	{
+		return mb_detect_encoding($remote_content,
 				'UTF-8,ISO-8859-1,ISO-8859-2,ISO-8859-3,'.
 				'ISO-8859-4,ISO-8859-5,ISO-8859-6,ISO-8859-7,ISO-8859-8,'.
Index: inc/prepend.php
===================================================================
--- inc/prepend.php	(revision 2711)
+++ inc/prepend.php	(revision 2713)
@@ -11,7 +11,4 @@
 # -- END LICENSE BLOCK -----------------------------------------
 
-/* Start tick  */
-define('DC_START_TIME',microtime(true));
-
 /* ------------------------------------------------------------------------------------------- */
 #  ClearBricks, DotClear classes auto-loader
@@ -29,55 +26,53 @@
 
 require CLEARBRICKS_PATH.'/_common.php';
-$__autoload['dcCore']        = dirname(__FILE__).'/core/class.dc.core.php';
-$__autoload['dcAuth']        = dirname(__FILE__).'/core/class.dc.auth.php';
-$__autoload['dcBlog']        = dirname(__FILE__).'/core/class.dc.blog.php';
-$__autoload['dcCategories']  = dirname(__FILE__).'/core/class.dc.categories.php';
-$__autoload['dcError']       = dirname(__FILE__).'/core/class.dc.error.php';
-$__autoload['dcMeta']        = dirname(__FILE__).'/core/class.dc.meta.php';
-$__autoload['dcMedia']       = dirname(__FILE__).'/core/class.dc.media.php';
-$__autoload['dcPostMedia']   = dirname(__FILE__).'/core/class.dc.postmedia.php';
-$__autoload['dcModules']     = dirname(__FILE__).'/core/class.dc.modules.php';
-$__autoload['dcPlugins']     = dirname(__FILE__).'/core/class.dc.plugins.php';
-$__autoload['dcThemes']      = dirname(__FILE__).'/core/class.dc.themes.php';
-$__autoload['dcRestServer']  = dirname(__FILE__).'/core/class.dc.rest.php';
-$__autoload['dcNamespace']   = dirname(__FILE__).'/core/class.dc.namespace.php';
-$__autoload['dcSettings']    = dirname(__FILE__).'/core/class.dc.settings.php';
-$__autoload['dcTrackback']   = dirname(__FILE__).'/core/class.dc.trackback.php';
-$__autoload['dcUpdate']      = dirname(__FILE__).'/core/class.dc.update.php';
-$__autoload['dcUtils']       = dirname(__FILE__).'/core/class.dc.utils.php';
-$__autoload['dcXmlRpc']      = dirname(__FILE__).'/core/class.dc.xmlrpc.php';
-$__autoload['dcLog']         = dirname(__FILE__).'/core/class.dc.log.php';
-$__autoload['dcWorkspace']   = dirname(__FILE__).'/core/class.dc.workspace.php';
-$__autoload['dcPrefs']       = dirname(__FILE__).'/core/class.dc.prefs.php';
-$__autoload['dcStore']       = dirname(__FILE__).'/core/class.dc.store.php';
-$__autoload['dcStoreReader'] = dirname(__FILE__).'/core/class.dc.store.reader.php';
-$__autoload['dcStoreParser'] = dirname(__FILE__).'/core/class.dc.store.parser.php';
-$__autoload['dcFavorites']   = dirname(__FILE__).'/admin/class.dc.favorites.php';
-
-$__autoload['rsExtPost']    = dirname(__FILE__).'/core/class.dc.rs.extensions.php';
-$__autoload['rsExtComment'] = dirname(__FILE__).'/core/class.dc.rs.extensions.php';
-$__autoload['rsExtDates']   = dirname(__FILE__).'/core/class.dc.rs.extensions.php';
-$__autoload['rsExtUser']    = dirname(__FILE__).'/core/class.dc.rs.extensions.php';
-
-$__autoload['dcMenu']            = dirname(__FILE__).'/admin/class.dc.menu.php';
-$__autoload['dcPage']            = dirname(__FILE__).'/admin/lib.dc.page.php';
-$__autoload['adminGenericList']  = dirname(__FILE__).'/admin/lib.pager.php';
-$__autoload['adminPostList']     = dirname(__FILE__).'/admin/lib.pager.php';
-$__autoload['adminPostMiniList'] = dirname(__FILE__).'/admin/lib.pager.php';
-$__autoload['adminCommentList']  = dirname(__FILE__).'/admin/lib.pager.php';
-$__autoload['adminUserList']     = dirname(__FILE__).'/admin/lib.pager.php';
-$__autoload['dcPager']           = dirname(__FILE__).'/admin/lib.pager.php';
-$__autoload['dcAdminCombos']     = dirname(__FILE__).'/admin/lib.admincombos.php';
-$__autoload['adminModulesList']  = dirname(__FILE__).'/admin/lib.moduleslist.php';
-$__autoload['adminThemesList']   = dirname(__FILE__).'/admin/lib.moduleslist.php';
-$__autoload['dcThemeConfig']     = dirname(__FILE__).'/admin/lib.themeconfig.php';
-
-$__autoload['dcTemplate']            = dirname(__FILE__).'/public/class.dc.template.php';
-$__autoload['context']               = dirname(__FILE__).'/public/lib.tpl.context.php';
-$__autoload['dcUrlHandlers']         = dirname(__FILE__).'/public/lib.urlhandlers.php';
-$__autoload['dcAdminURL']            = dirname(__FILE__).'/admin/lib.dc.adminurl.php';
-$__autoload['dcPostsActionsPage']    = dirname(__FILE__).'/admin/actions/class.dcactionposts.php';
-$__autoload['dcCommentsActionsPage'] = dirname(__FILE__).'/admin/actions/class.dcactioncomments.php';
-$__autoload['dcActionsPage']         = dirname(__FILE__).'/admin/actions/class.dcaction.php';
+$__autoload['dcCore']				= dirname(__FILE__).'/core/class.dc.core.php';
+$__autoload['dcAuth']				= dirname(__FILE__).'/core/class.dc.auth.php';
+$__autoload['dcBlog']				= dirname(__FILE__).'/core/class.dc.blog.php';
+$__autoload['dcCategories']			= dirname(__FILE__).'/core/class.dc.categories.php';
+$__autoload['dcError']				= dirname(__FILE__).'/core/class.dc.error.php';
+$__autoload['dcMeta']				= dirname(__FILE__).'/core/class.dc.meta.php';
+$__autoload['dcMedia']				= dirname(__FILE__).'/core/class.dc.media.php';
+$__autoload['dcPostMedia']				= dirname(__FILE__).'/core/class.dc.postmedia.php';
+$__autoload['dcModules']				= dirname(__FILE__).'/core/class.dc.modules.php';
+$__autoload['dcPlugins']				= dirname(__FILE__).'/core/class.dc.plugins.php';
+$__autoload['dcThemes']				= dirname(__FILE__).'/core/class.dc.themes.php';
+$__autoload['dcRestServer']			= dirname(__FILE__).'/core/class.dc.rest.php';
+$__autoload['dcNamespace']			= dirname(__FILE__).'/core/class.dc.namespace.php';
+$__autoload['dcSettings']			= dirname(__FILE__).'/core/class.dc.settings.php';
+$__autoload['dcTrackback']			= dirname(__FILE__).'/core/class.dc.trackback.php';
+$__autoload['dcUpdate']				= dirname(__FILE__).'/core/class.dc.update.php';
+$__autoload['dcUtils']				= dirname(__FILE__).'/core/class.dc.utils.php';
+$__autoload['dcXmlRpc']				= dirname(__FILE__).'/core/class.dc.xmlrpc.php';
+$__autoload['dcLog']				= dirname(__FILE__).'/core/class.dc.log.php';
+$__autoload['dcWorkspace']			= dirname(__FILE__).'/core/class.dc.workspace.php';
+$__autoload['dcPrefs']				= dirname(__FILE__).'/core/class.dc.prefs.php';
+$__autoload['dcStore']			= dirname(__FILE__).'/core/class.dc.store.php';
+$__autoload['dcStoreReader']		= dirname(__FILE__).'/core/class.dc.store.reader.php';
+$__autoload['dcStoreParser']		= dirname(__FILE__).'/core/class.dc.store.parser.php';
+$__autoload['dcFavorites']			= dirname(__FILE__).'/admin/class.dc.favorites.php';
+
+$__autoload['rsExtPost']				= dirname(__FILE__).'/core/class.dc.rs.extensions.php';
+$__autoload['rsExtComment']			= dirname(__FILE__).'/core/class.dc.rs.extensions.php';
+$__autoload['rsExtDates']			= dirname(__FILE__).'/core/class.dc.rs.extensions.php';
+$__autoload['rsExtUser']				= dirname(__FILE__).'/core/class.dc.rs.extensions.php';
+
+$__autoload['dcMenu']				= dirname(__FILE__).'/admin/class.dc.menu.php';
+$__autoload['dcPage']				= dirname(__FILE__).'/admin/lib.dc.page.php';
+$__autoload['adminGenericList']		= dirname(__FILE__).'/admin/lib.pager.php';
+$__autoload['adminPostList']			= dirname(__FILE__).'/admin/lib.pager.php';
+$__autoload['adminPostMiniList']		= dirname(__FILE__).'/admin/lib.pager.php';
+$__autoload['adminCommentList']		= dirname(__FILE__).'/admin/lib.pager.php';
+$__autoload['adminUserList']			= dirname(__FILE__).'/admin/lib.pager.php';
+$__autoload['dcPager']		= dirname(__FILE__).'/admin/lib.pager.php';
+$__autoload['dcAdminCombos']			= dirname(__FILE__).'/admin/lib.admincombos.php';
+$__autoload['adminModulesList']			= dirname(__FILE__).'/admin/lib.moduleslist.php';
+$__autoload['adminThemesList']			= dirname(__FILE__).'/admin/lib.moduleslist.php';
+
+$__autoload['dcTemplate']			= dirname(__FILE__).'/public/class.dc.template.php';
+$__autoload['context']				= dirname(__FILE__).'/public/lib.tpl.context.php';
+$__autoload['dcUrlHandlers']			= dirname(__FILE__).'/public/lib.urlhandlers.php';
+$__autoload['dcPostsActionsPage']			= dirname(__FILE__).'/admin/actions/class.dcactionposts.php';
+$__autoload['dcCommentsActionsPage']			= dirname(__FILE__).'/admin/actions/class.dcactioncomments.php';
+$__autoload['dcActionsPage']			= dirname(__FILE__).'/admin/actions/class.dcaction.php';
 
 # Clearbricks extensions
@@ -140,11 +135,10 @@
 # Constants
 define('DC_ROOT',path::real(dirname(__FILE__).'/..'));
-define('DC_VERSION','2.7-dev');
+define('DC_VERSION','2.6.4');
 define('DC_DIGESTS',dirname(__FILE__).'/digests');
 define('DC_L10N_ROOT',dirname(__FILE__).'/../locales');
 define('DC_L10N_UPDATE_URL','http://services.dotclear.net/dc2.l10n/?version=%s');
-define('DC_DISTRIB_PLUGINS','aboutConfig,akismet,antispam,attachments,blogroll,blowupConfig,dclegacy,fairTrackbacks,importExport,maintenance,pages,pings,simpleMenu,tags,themeEditor,userPref,widgets,dcLegacyEditor');
-define('DC_DISTRIB_THEMES','berlin,blueSilence,blowupConfig,customCSS,default,ductile');
-define('DC_DEFAULT_TPLSET','mustek');
+define('DC_DISTRIB_PLUGINS','aboutConfig,akismet,antispam,attachments,blogroll,blowupConfig,dclegacy,fairTrackbacks,importExport,maintenance,pages,pings,simpleMenu,tags,themeEditor,userPref,widgets');
+define('DC_DISTRIB_THEMES','blueSilence,blowupConfig,customCSS,default,ductile');
 
 if (!defined('DC_VENDOR_NAME')) {
Index: inc/public/class.dc.template.php
===================================================================
--- inc/public/class.dc.template.php	(revision 2666)
+++ inc/public/class.dc.template.php	(revision 2590)
@@ -235,4 +235,102 @@
 	}
 
+	protected function compileFile($file)
+	{
+		$fc = file_get_contents($file);
+
+		$this->compile_stack[] = $file;
+
+		# Remove every PHP tags
+		if ($this->remove_php)
+		{
+			$fc = preg_replace('/<\?(?=php|=|\s).*?\?>/ms','',$fc);
+		}
+
+		# Transform what could be considered as PHP short tags
+		$fc = preg_replace('/(<\?(?!php|=|\s))(.*?)(\?>)/ms',
+		'<?php echo "$1"; ?>$2<?php echo "$3"; ?>',$fc);
+
+		# Remove template comments <!-- #... -->
+		$fc = preg_replace('/(^\s*)?<!-- #(.*?)-->/ms','',$fc);
+
+		# Lexer part : split file into small pieces
+		# each array entry will be either a tag or plain text
+		$blocks = preg_split(
+			'#(<tpl:\w+[^>]*>)|(</tpl:\w+>)|({{tpl:\w+[^}]*}})#msu',$fc,-1,
+			PREG_SPLIT_DELIM_CAPTURE|PREG_SPLIT_NO_EMPTY);
+
+		# Next : build semantic tree from tokens.
+		$rootNode = new tplNode();
+		$node = $rootNode;
+		$errors = array();
+		foreach ($blocks as $id => $block) {
+			$isblock = preg_match('#<tpl:(\w+)(?:(\s+.*?)>|>)|</tpl:(\w+)>|{{tpl:(\w+)(\s(.*?))?}}#ms',$block,$match);
+			if ($isblock == 1) {
+				if (substr($match[0],1,1) == '/') {
+					// Closing tag, check if it matches current opened node
+					$tag = $match[3];
+					if (($node instanceof tplNodeBlock) && $node->getTag() == $tag) {
+						$node->setClosing();
+						$node = $node->getParent();
+					} else {
+						// Closing tag does not match opening tag
+						// Search if it closes a parent tag
+						$search = $node;
+						while($search->getTag() != 'ROOT' && $search->getTag() != $tag) {
+							$search = $search->getParent();
+						}
+						if ($search->getTag() == $tag) {
+							$errors[] = sprintf(
+								__('Did not find closing tag for block <tpl:%s>. Content has been ignored.'),
+								html::escapeHTML($node->getTag()));
+							$search->setClosing();
+							$node = $search->getParent();
+						} else {
+							$errors[]=sprintf(
+								__('Unexpected closing tag </tpl:%s> found.'),
+								$tag);;
+						}
+					}
+				} elseif (substr($match[0],0,1) == '{') {
+					// Value tag
+					$tag = $match[4];
+					$str_attr = '';
+					$attr = array();
+					if (isset($match[6])) {
+						$str_attr = $match[6];
+						$attr = $this->getAttrs($match[6]);
+					}
+					$node->addChild(new tplNodeValue($tag,$attr,$str_attr));
+				} else {
+					// Opening tag, create new node and dive into it
+					$tag = $match[1];
+					$newnode = new tplNodeBlock($tag,isset($match[2])?$this->getAttrs($match[2]):array());
+					$node->addChild($newnode);
+					$node = $newnode;
+				}
+			} else {
+				// Simple text
+				$node->addChild(new tplNodeText($block));
+			}
+		}
+
+		if (($node instanceof tplNodeBlock) && !$node->isClosed()) {
+			$errors[] = sprintf(
+				__('Did not find closing tag for block <tpl:%s>. Content has been ignored.'),
+				html::escapeHTML($node->getTag()));
+		}
+
+		$err = "";
+		if (count($errors) > 0) {
+			$err = "\n\n<!-- \n".
+				__('WARNING: the following errors have been found while parsing template file :').
+				"\n * ".
+				join("\n * ",$errors).
+				"\n -->\n";
+		}
+
+		return $rootNode->compile($this).$err;
+	}
+
 	public function compileBlockNode($tag,$attr,$content)
 	{
@@ -245,5 +343,9 @@
 		$this->core->callBehavior('templateInsideBlock',$this->core,$this->current_tag,$attr,array(&$content));
 
-		$res .= parent::compileBlockNode($this->current_tag,$attr,$content);
+		if (isset($this->blocks[$this->current_tag])) {
+			$res .= call_user_func($this->blocks[$this->current_tag],$attr,$content);
+		} elseif ($this->unknown_block_handler != null) {
+			$res .= call_user_func($this->unknown_block_handler,$this->current_tag,$attr,$content);
+		}
 
 		# --BEHAVIOR-- templateAfterBlock
@@ -261,5 +363,9 @@
 		$res = $this->core->callBehavior('templateBeforeValue',$this->core,$this->current_tag,$attr);
 
-		$res .= parent::compileValueNode($this->current_tag,$attr,$str_attr);
+		if (isset($this->values[$this->current_tag])) {
+			$res .= call_user_func($this->values[$this->current_tag],$attr,ltrim($str_attr));
+		} elseif ($this->unknown_value_handler != null) {
+			$res .= call_user_func($this->unknown_value_handler,$this->current_tag,$attr,$str_attr);
+		}
 
 		# --BEHAVIOR-- templateAfterValue
@@ -267,4 +373,18 @@
 
 		return $res;
+	}
+
+	public function setUnknownValueHandler($callback)
+	{
+		if (is_callable($callback)) {
+			$this->unknown_value_handler = $callback;
+		}
+	}
+
+	public function setUnknownBlockHandler($callback)
+	{
+		if (is_callable($callback)) {
+			$this->unknown_block_handler = $callback;
+		}
 	}
 
@@ -276,5 +396,4 @@
 		$p[3] = '0';	# lower_case
 		$p[4] = '0';	# upper_case or capitalize
-		$p[5] = '0';    # encode_url
 
 		$p[0] = (integer) (!empty($attr['encode_xml']) || !empty($attr['encode_html']));
@@ -288,5 +407,4 @@
 		$p[4] = (integer) !empty($attr['upper_case']);
 		$p[4] = (!empty($attr['capitalize']) ? 2 : $p[4]);
-		$p[5] = (integer) !empty($attr['encode_url']);
 
 		return "context::global_filter(%s,".implode(",",$p).",'".addslashes($this->current_tag)."')";
@@ -387,33 +505,4 @@
 	}
 
-	public function displayCounter($variable,$values,$attr,$count_only_by_default=false) {
-		if (isset($attr['count_only'])) {
-			$count_only=($attr['count_only']==1);
-		} else {
-			$count_only = $count_only_by_default;
-		}
-		if ($count_only) {
-			return "<?php echo ".$variable."; ?>";
-		} else {
-			$v=$values;
-			if (isset($attr['none'])) {
-				$v['none'] = addslashes($attr['none']);
-			}
-			if (isset($attr['one'])) {
-				$v['one'] = addslashes($attr['one']);
-			}
-			if (isset($attr['more'])) {
-				$v['more'] = addslashes($attr['more']);
-			}
-			return
-				"<?php if (".$variable." == 0) {\n".
-				"  printf(__('".$v['none']."'),".$variable.");\n".
-				"} elseif (".$variable." == 1) {\n".
-				"  printf(__('".$v['one']."'),".$variable.");\n".
-				"} else {\n".
-				"  printf(__('".$v['more']."'),".$variable.");\n".
-				"} ?>";
-		}
-	}
 	/* TEMPLATE FUNCTIONS
 	------------------------------------------------------- */
@@ -576,14 +665,5 @@
 	{
 		$f = $this->getFilters($attr);
-		return $this->displayCounter(
-			sprintf($f,'$_ctx->archives->nb_post'),
-			array(
-				'none' => 'no archive',
-				'one'  => 'one archive',
-				'more' => '%d archives'
-			),
-			$attr,
-			true
-		);
+		return '<?php echo '.sprintf($f,'$_ctx->archives->nb_post').'; ?>';
 	}
 
@@ -1061,14 +1141,5 @@
 	{
 		$f = $this->getFilters($attr);
-		return $this->displayCounter(
-			sprintf($f,'$_ctx->categories->nb_post'),
-			array(
-				'none' => 'No post',
-				'one'  => 'One post',
-				'more' => '%d posts'
-			),
-			$attr,
-			true
-		);
+		return '<?php echo '.sprintf($f,'$_ctx->categories->nb_post').'; ?>';
 	}
 
@@ -1102,18 +1173,13 @@
 
 		if ($lastn != 0) {
-			// Set limit (aka nb of entries needed)
 			if ($lastn > 0) {
-				// nb of entries per page specified in template -> regular pagination
 				$p .= "\$params['limit'] = ".$lastn.";\n";
 			} else {
-				// nb of entries per page not specified -> use ctx settings
-				$p .= "\$params['limit'] = (\$_page_number == 1 ? \$_ctx->nb_entry_first_page : \$_ctx->nb_entry_per_page);\n";
+				$p .= "\$params['limit'] = \$_ctx->nb_entry_per_page;\n";
 			}
-			// Set offset (aka index of first entry)
+
 			if (!isset($attr['ignore_pagination']) || $attr['ignore_pagination'] == "0") {
-				// standard pagination, set offset
-				$p .= "\$params['limit'] = array((\$_page_number == 1 ? 0 : (\$_page_number - 2) * \$_ctx->nb_entry_per_page + \$_ctx->nb_entry_first_page),\$params['limit']);\n";
+				$p .= "\$params['limit'] = array(((\$_page_number-1)*\$params['limit']),\$params['limit']);\n";
 			} else {
-				// no pagination, get all posts from 0 to limit
 				$p .= "\$params['limit'] = array(0, \$params['limit']);\n";
 			}
@@ -1769,7 +1835,4 @@
 	}
 
-
-
-
 	/*dtd
 	<!ELEMENT tpl:EntryCommentCount - O -- Number of comments for entry -->
@@ -1783,4 +1846,18 @@
 	public function EntryCommentCount($attr)
 	{
+		$none = 'no comment';
+		$one = 'one comment';
+		$more = '%d comments';
+
+		if (isset($attr['none'])) {
+			$none = addslashes($attr['none']);
+		}
+		if (isset($attr['one'])) {
+			$one = addslashes($attr['one']);
+		}
+		if (isset($attr['more'])) {
+			$more = addslashes($attr['more']);
+		}
+
 		if (empty($attr['count_all'])) {
 			$operation = '$_ctx->posts->nb_comment';
@@ -1789,14 +1866,12 @@
 		}
 
-		return $this->displayCounter(
-			$operation,
-			array(
-				'none' => 'no comments',
-				'one'  => 'one comment',
-				'more' => '%d comments'
-				),
-			$attr,
-			false
-		);
+		return
+		"<?php if (".$operation." == 0) {\n".
+		"  printf(__('".$none."'),".$operation.");\n".
+		"} elseif (".$operation." == 1) {\n".
+		"  printf(__('".$one."'),".$operation.");\n".
+		"} else {\n".
+		"  printf(__('".$more."'),".$operation.");\n".
+		"} ?>";
 	}
 
@@ -1811,14 +1886,26 @@
 	public function EntryPingCount($attr)
 	{
-		return $this->displayCounter(
-			'$_ctx->posts->nb_trackback',
-			array(
-				'none' => 'no trackback',
-				'one'  => 'one trackback',
-				'more' => '%d trackbacks'
-				),
-			$attr,
-			false
-		);
+		$none = 'no trackback';
+		$one = 'one trackback';
+		$more = '%d trackbacks';
+
+		if (isset($attr['none'])) {
+			$none = addslashes($attr['none']);
+		}
+		if (isset($attr['one'])) {
+			$one = addslashes($attr['one']);
+		}
+		if (isset($attr['more'])) {
+			$more = addslashes($attr['more']);
+		}
+
+		return
+		"<?php if (\$_ctx->posts->nb_trackback == 0) {\n".
+		"  printf(__('".$none."'),(integer) \$_ctx->posts->nb_trackback);\n".
+		"} elseif (\$_ctx->posts->nb_trackback == 1) {\n".
+		"  printf(__('".$one."'),(integer) \$_ctx->posts->nb_trackback);\n".
+		"} else {\n".
+		"  printf(__('".$more."'),(integer) \$_ctx->posts->nb_trackback);\n".
+		"} ?>";
 	}
 
